// test / demo file for the performance counters stuff
// Vsn 1.0 : Worked reasonably, no test material available.
// Vsn 1.1 : My understanding of the duration flag (now "numbers") was wrong.

/*
  C:\MSDEV\Projects\perf\Release>perf -e0 443 -e1 442 -e2 c0 -e3 80 -p ls
  MAIN.obj
  PERFCTRS.obj
  perf.exe
  perf.pch
  perfctrs.dll
  Elapsed time 11.47 ms
  [0x0443] : 2517
  [0x0442] : 1264
  [0x00C0] : 883711
  [0x0080] : 405588
*/

#include <stdio.h>
#include <windows.h>
#include "../perfctrs/perfctrs.h"

int wevt0 = EVT_DATA_MEM_REFS_E;
int wevt1 = EVT_DATA_CACHE_REFILL_L2_E;
int wevt2 = EVT_INST_RETIRED;
int wevt3 = EVT_IFU_IFETCH;
int verbose = 0;
char command[1024] = {0}; 

void usage(char *pname, char *err) {
	if (err[0] != '\0') fprintf(stderr,"Problem: %s.\n\n",err);
	fprintf(stderr,"Execute a program with performance counters enabled.\n");
	fprintf(stderr,"Usage: %s [-e[i]] event -p program arguments\n",pname); }

void setupevent(int a, char *b[], int c) {
	switch(b[c][2]) {
	case '0': sscanf(b[c+1],"%p",&wevt0); break; // expects "-e0 43"
	case '1': sscanf(b[c+1],"%p",&wevt1); break; // expects "-e1 C0"
	case '2': sscanf(b[c+1],"%p",&wevt2); break; // etc.
	case '3': sscanf(b[c+1],"%p",&wevt3); break;
	default : fprintf(stderr,"Unknown option %s\n",b); break;}}

void runprogram(int a, char *b[], int c) {
    int i; char *space = " ";
    for (i=c+1; i<a; i++) {
		strcat(command,b[i]); 
		strcat(command,space);}}

void options(int argc,char *argv[]) {
	int i; int nothing = 1;
	for (i=1; i < argc; i++) {
		if (argv[i][0] == '/' || argv[i][0] == '-') {
			switch (argv[i][1]) {
			    case 'v': 
			    case 'V': verbose = 1; break;
				case '?':
				case 'h':
				case 'H': usage(argv[0],""); break;
				case 'E':
				case 'e': setupevent(argc,argv,i); i++; break;
				case 'P':
				case 'p': runprogram(argc,argv,i); nothing = 0; i = argc; break;
				default : fprintf(stderr,"Unknown option %s\n",argv[i]); break; }}}
	if (nothing) usage(argv[0],""); }

int main (int argc,char *argv[]) {
  bool user = true, os = false, numbers = true;
  __int64 tsc, evt0, evt1, evt2, evt3, ts_clock;
  DWORD millisecs;
  double ticksPerMsec;
  struct CPU_ID *id = GetCPU_ID();
  const char *txt = PrintID(id);
  bool timeStamp = CanDoTimeStamp();
  bool perfmon = CanDoPerfMon();

  if (!timeStamp) return printf("Your processor can't do timestamping.\n");
  if (!perfmon)   return printf("Your processor can't do performance monitoring.\n"); 
  
  millisecs = GetTickCount();
  ts_clock = TimeStamp();
    Sleep(1000);
  millisecs = GetTickCount() - millisecs;
  ts_clock = TimeStamp() - ts_clock;
  ticksPerMsec = (double)ts_clock/((double)millisecs);

  options(argc,argv);

  if(verbose) {
	printf("CPUID returned:\n%s\n", txt);
	printf("\nCanDoTimeStamp: %d\nCanDoPerfMon: %d\n", timeStamp, perfmon);  
    printf("Timestamp counter speed %0.0f counts per millisecond.\n\n", ticksPerMsec);}

// Count # data references, refills from L2 cache, retired instructions ...
InitMSR ();
    WriteMSR(MSR_PERFCTR0, 0); 
	SetEventCounter(0, wevt0, user, os, numbers); evt0 = ReadPerfCtr(0); 
	SetEventCounter(1, wevt1, user, os, numbers); evt1 = ReadPerfCtr(1); 
	SetEventCounter(2, wevt2, user, os, numbers); evt2 = ReadPerfCtr(2); 
	SetEventCounter(3, wevt3, user, os, numbers); evt3 = ReadPerfCtr(3); 
	tsc = TimeStamp();
	  if (command[0] != '\0') system(command);
    tsc = (TimeStamp() - tsc); 
	evt0 = (ReadPerfCtr(0) - evt0);
	evt1 = (ReadPerfCtr(1) - evt1);
	evt2 = (ReadPerfCtr(2) - evt2);
	evt3 = (ReadPerfCtr(3) - evt3);
    printf("Elapsed time %0.02f ms\n", (double)tsc/ticksPerMsec);
    printf("[0x%04X] : %0.0f\n", wevt0,(double)evt0);
    printf("[0x%04X] : %0.0f\n", wevt1,(double)evt1);
    printf("[0x%04X] : %0.0f\n", wevt2,(double)evt2);
    printf("[0x%04X] : %0.0f\n", wevt3,(double)evt3);
ExitMSR ();

return 0; }

/* End of File */