// Adapted for VDT frame grabber by sjs 1995

// gpioctl.h    Include file for Generic Port I/O Example Driver
//
// Define the IOCTL codes we will use.  The IOCTL code contains a command
// identifier, plus other information about the device, the type of access
// with which the file must have been opened, and the type of buffering.
//
// Robert B. Nelson (Microsoft)     March 1, 1993

// Device type           -- in the "User Defined" range."
#define PERFMON_TYPE 40000

// The IOCTL function codes from 0x800 to 0xFFF are for customer use.

#define IOCTL_WRITE_MSR\
    CTL_CODE( PERFMON_TYPE,  0x910, METHOD_BUFFERED, FILE_WRITE_ACCESS)

#define IOCTL_READ_MSR\
    CTL_CODE( PERFMON_TYPE,  0x900, METHOD_BUFFERED, FILE_READ_ACCESS)

#define IOCTL_ENABLE_CR4_BITS\
    CTL_CODE( PERFMON_TYPE,  0x920, METHOD_BUFFERED, FILE_READ_ACCESS)




typedef struct  _WRITE_MSR_INPUT {
    ULONG   RegNumber; 
    ULONG   LoData;
    ULONG   HiData;
}   WRITE_MSR_INPUT ;
